#include <stdint.h>
#include <time.h>

#ifdef __SIZEOF_INT128__
	typedef unsigned __int128 uint128_t;
#endif

enum code_purpose {
	ACCESS,
	DISCOUNT,
};

struct code {
	time_t unix_ts_sec;
	long unix_ts_msec;
	enum code_purpose purpose;
	uint16_t rand_a;
	uint64_t rand_b;
};

int code_init(struct code *key);

uint128_t code_convert_to_num(struct code *key);
