#include <stdint.h>
#include <stdio.h>
#include <sys/random.h>
#include <time.h>

#include "code.h"
#include "errors.h"

int code_init(struct code *key) {
	struct timespec ts;

	if (clock_gettime(CLOCK_REALTIME, &ts) == -1) {
		perror("Unable to read clock 'CLOCK_REALTIME'");
		return ERR_CLOCK_READ;
	}



	key->unix_ts_sec = ts.tv_sec;
	key->unix_ts_msec = ts.tv_nsec / 1000000;
	key->purpose = ACCESS;

	return 0;
}
